// C Source File//////////////////////////////////////////////////////////
// Created   6/24/2003; 11:32:12 AM //////////////////////////////////////
// Completed 12/13/2004; 9:41:59 PM //////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
////////~~~~/~~~~//~~~~~~//~~~///~~//~~~~~~//~~~~~~~//~~/////~~~///~~/////
///////~~/~~~//~~//~~//~~//~~~~//~~//~~//~~//~~///~~//~~//////~~~/~~//////
//////~~//~~///~~//~~//~~//~~~~~~~~//~~//~~//~~~~~~~//~~///////~~~~///////
/////~~////////~~//~~//~~//~~//~~~~//~~//~~//~~///////~~////////~~////////
////~~/////////~~//~~~~~~//~~///~~~//~~~~~~//~~///////~~~~~////~~/////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////AngelBoy@FoxValley.net//////////////////////////
//////////////////////////////////////////////////////////////////////////
// Copyright 2004  Jeff - under the GNU License for Free Software       //
// None of these files may be sold or reproduced for a profit           //
//////////////////////////////////////////////////////////////////////////

/* Todo:
	AI calculate if it is a fair trade
*/

/* Beta Testers:
	Trade, money prompt
	FileIO
	Settings Menu
	Limit Houses
	Debt Menu, Tax Day Menu, Jail Menu
	heartBeat speed
	Moving board
	Chance: Advance to nearest Utility
	ControlBoard() (Save/Restore Scr)
*/


// These next two options control who begins owning all
// of the property and how many houses there are
//#define OWNER_OF_PROP   1
//#define NUM_HOUSES      5

// The new AI that I was working on
//#ADVANCED_AI

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>
#include "graphics.h"
#include "functions.h"
#include "English.h"



typedef struct {
  enum Bool stillPlaying[8];
  enum Bool aiOn[8];
  int inJail[8];
  int position[8];
  int money[8];
  unsigned int getOutFree[8];

  int players;
  int numPlaying;
  int turn;
  int chanceCard;
  int cchestCard;
  unsigned int rolled_1;
  unsigned int rolled_2;
  unsigned int numDoubles;
  unsigned int pay;
  unsigned int payRRdouble;
  unsigned int payUtmore;
  unsigned int numPropOwned;
  int numHousesLeft;
  int numHotelsLeft;
  unsigned int freeParking;
  enum Bool gotOut;

  int owner[22];
  int mortgaged[22];
  int numHouses[22];
  int rrOwner[4];
  int rrMortgaged[4];
  int utOwner[2];
  int utMortgaged[2];

  unsigned int chanceCards[15];
  unsigned int cchestCards[15];

  int saving[8];
  int houseToBuy;
  int numHousesToBuy;
  int dontBuyHouses[8];

  enum Bool animation;
  enum Bool FPJackpot;
  enum Bool inDebt;
  enum Bool limitHouses;
  enum Bool autoSave;

  unsigned int soldWidth;

  int boardX;
  int boardY;
} SAVED_GAME;

/////////////////////////
// Function Prototypes //
/////////////////////////
void playGame(enum Bool GameType);                     // The main function for the game
void addPrevNext(int stats[2][40], int col);           // Splits up the trade array and adds a Previous and Next every 8
int arraySum8(int array[8]);                           // Returns the sum of an array with 8 elements
enum Bool canAddHouse(int prop);                       // Determines if a player can add a house on a property group
enum Bool canRemoveHouse(int prop);                    // Determines if a player can remove a house on a property group
void clearProp(int player);                            // Clears all property that belonged to a player and turns them off
void debtMenu(int player);                             // Prompts a player to get themselves out of debt
void drawHomeScreen(void);                             // Draws the nice (new) homescreen pic that I spent 45 min making
void drawPropInfo(int o, enum Bool m, int mC, int pC); // Simplifies the displaying of info in the property cards
void editPlayers(void);                                // GUI interface for choosing which players are on and AI
void endGame(int winner);                              // The function to display bill gates at the end
void Exit() __attribute__ ((noreturn));                // Exits the program, turns off grayscale, cleans up
void fadeOut(int x1, int y1, int x2, int y2);          // Takes an inversed square and slowly changes it back to normal
unsigned long GNI(int xPos);                           // Prompts for and returns a number entered by the user
enum Bool groupOwner(int pos);                         // Determines if a player is the owner of a group
void heartBeat(void);                                  // Waits a few milliseconds (a heartbeat)
int higherHouse(int h1,int h2);                        // Returns the number of houses of the property that has the most
void Info(void);                                       // Scrolls information about and beta testers for the game
int isOwner(int pos, int player);                      // Checks if player is owner
void jailMenu(void);                                   // Shows players their options if in jail
int lowerHouse(int h1,int h2);                         // Retuns the number of houses of the property that has the least
void pause(void);                                      // Pause and wait for user input. If they press ESC, exit
int payDouble(int pos);                                // If the player owns all property on that group
void property(void);                                   // Allows the user to edit their property with mortgages and houses
void putForSale(int cost);                             // Shows options and pricing for a property piece up for sale
void quickSaveScr(void);                               // Quickly saves the grayscale screen
void quickRestoreScr(void);                            // Quickly restores the grayscale screen
void reloadSettings(int pos);                          // Brings up the settings menu and reloads the icons
int rrCalc(int num);                                   // Serves as a lookup (table) for railroads
int rrRent(int curRR);                                 // Determines the amount of rent a person has to pay for a railroad
enum Bool saveGame(void);                              // Returns 1 if game was saved successfully, 0 if not
void settingsCursor(int cursorX, int cursorY);         // Displays the cursor for the settings menu
void settingsIcon(int x, int y, int num);              // Displays an icon at X,Y
void settingsMenu(void);                               // Shows an icon-based menu to edit the current settings
void showPlayerInfo(void);                             // Displays the info at the top right corner of the screen
void showPropCard(int i);                              // Shows a property card with information about that piece of prop
void showStats(int i);                                 // Displays the prop card and lets the user select properties
void sold(void);                                       // Pops up with a 'Sold' message
void trade(void);                                      // Allows a user to trade property and money with other players
inline int utCalc(int num);                            // Serves as a lookup for utilities
int waitOnMenu(unsigned int xStart, unsigned int xEnd,unsigned int yStart, unsigned int optionHeight,
			unsigned char menuOptions, enum Bool useLR, enum Bool scrollBoard);// Handles a set of inversing squares for a menu
void youPaid(void);                                    // Displays the amount of money a person paid

//#define utCalc(x) ((x == 12)?0:1)

//////////////////////
// Global Variables //
//////////////////////
// The main set of variables needed for the game
SAVED_GAME game;
// Lookup table to convert from 40 squares to the proper position in the property arrays
// -1 is for RR's, and -2 is for Utilities
int convert[]= {0,0,0,1,0,-1,2,0,3,4,0,5,-2,6,7,-1,8,0,9,10,0,11,0,12,13,-1,14,15,-2,16,0,17,18,0,19,-1,0,20,0,21};
// Keep these global for the AI to use
int houseCost   [22] = {50,50, 50, 50, 50,100,100,100,100,100,100,150,150,150,150,150,150,200,200,200,200,200};
int mortgageCost[22] = {30,30, 50, 50, 60, 70, 70, 80, 90, 90,100,110,110,120,130,130,140,150,150,160,175,200};
int buyCost     [22] = {60,60,100,100,120,140,140,160,180,180,200,220,220,240,260,260,280,300,300,320,350,400};
// Lookup table for the settings cursor X position
int xStart[] = {74,98,134,151};
// Spot to save/restore the homescreen
unsigned char *home;//[3840];
// For strings
char buffer[50];
// Used for quickly saving and restoring a screen (i.e. during a popup message)
LCD_BUFFER LCD_tmp1;
LCD_BUFFER LCD_tmp2;
// I remove the 1st and 5th interrupt for low-level keyboard reading (rowread and _keytest)
INT_HANDLER save_int_1;
// Some system variables that differ between languages//, place a default on them just in case
int soldWidth;// = 30;
int partnerWidth;// = 30;
int dontOwnPropWidth;// = 75;
int savedWidth;// = 30;
int errorWidth;// = 75;
int transferWidth;// = 36;
int autosaveWidth;
// Placement for the animated icons in the settings menu
int settingsIconPlacementX[] = {77,76,75,69,60,48,32};
int settingsIconPlacementY[] = {50,37,24,14,9,7,6};
// Titles for the options in the settings menu
const char *optionTitles[] = {PLAY_GAME,PLAYERS,ANIMATION,FP_JACKPOT,IN_DEBT,LIMIT_HOUSES,AUTO_SAVE_GAME};
// Lookup table for the options under settings menu
enum Bool* settingsOptions[] = {&game.animation,&game.FPJackpot,&game.inDebt,&game.limitHouses,&game.autoSave};
// The other houses in each group for any piece of property
unsigned char houseGroups[22][2] = {
	{1,1},{0,0},{3,4},{2,4},{2,3},{6,7},{5,7},{5,6},{9,10},{8,10},{8,9},{12,13},{11,13},{11,12},{15,16},{14,16},{14,15},
	{18,19},{17,19},{17,18},{21,21},{20,20}};
// Lookups for digit buttons with _keytest in GNI()
const unsigned char row[] = {4,4,3,2,4,3,2,4,3,2};
const unsigned char col[] = {0,1,1,1,2,2,2,3,3,3};
int keyPressed;
// Some variables for trading
// I really need to cut back on them
int column;							// Current column. 0 & 1 are player and partner. 3 is the middle (arrows)
int options[2][40];			// Which options are open for them to trade. These are displayed on the screen
enum Bool stats[2][40];	// If the corresponding option is selected to be traded


#include "FileIO.h"						// Saving and Loading game functions
#include "Board.h"						// Functions for moving and modifying the game board
#include "AI.h"               // All of the AI functions


// Main Function
void _main(void)
{
	TRY
    home = NULL;
    if ((home = malloc(LCD_SIZE)) == NULL) {
      ST_helpMsg(NOT_ENOUGH_MEMORY);
      ER_success();
      return;
    }

    // Save the homescreen
	  memcpy(home,LCD_MEM,LCD_SIZE);

  	// Point the first and the fifth interrupt to nothing
  	save_int_1 = GetIntVec(AUTO_INT_1);
    SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
  	//save_int_5 = GetIntVec(AUTO_INT_5);
    //SetIntVec(AUTO_INT_5,DUMMY_HANDLER);

    // Turn on grayscale. If it doesn't work, restore interrupts and exit
    if(!GrayOn()) { SetIntVec(AUTO_INT_1,save_int_1); return; ER_success(); }

		//controlBoard();

    // Finish setting up
    randomize();
    drawHomeScreen(); // Removed ClrScr(), this function will cover the screen so I don't need to clear it
    int i = 0;

		// Calculate these widths once for the current language and use them the rest of the game
		// Will be recalculated if the saved game is transfered to a different language
		soldWidth = (DrawStrWidth(SOLD, F_8x10) >> 1);								// Sold!
		partnerWidth = (DrawStrWidth(PARTNER, F_4x6) >> 1);						// Partner?
		dontOwnPropWidth = (DrawStrWidth(DONT_OWN_PROP, F_4x6) >> 1); // You do not own any property!
		savedWidth = (DrawStrWidth(SAVED, F_8x10) >> 1);							// Saved
		errorWidth = (DrawStrWidth(ERROR, F_8x10) >> 1);							// Error
		transferWidth = (DrawStrWidth(TRANSFER_AMOUNT, F_4x6) >> 1);	// Transfer amount?
		if(transferWidth < 36) transferWidth = 36;
		autosaveWidth = (DrawStrWidth(ERROR_SAVING_GAME, F_4x6) >> 1);// Error Saving Game \n Autosave Turned Off
		if(autosaveWidth < (DrawStrWidth(AUTOSAVE_TURNED_OFF, F_4x6) >> 1))
			autosaveWidth = (DrawStrWidth(AUTOSAVE_TURNED_OFF, F_4x6) >> 1);//Take the widest one

    while(1) {
      // Draw the current option's icon (NEW, LOAD, HELP, EXIT)
			Sprite32_mask(125,65,32,(unsigned long *)introIcons + (i << 5),(unsigned long *)introIcons + (i << 5) + 128);

			heartBeat();
			heartBeat();

      do { // Saves power
        pokeIO(0x600005,0b10011);
        // Check for APD
				checkAPD();
      } while(!_rowread(0));

      // If a key was pressed, do something about it
   	  if(_keytest(RR_DOWN)&&(i++ == 3)) i = 0;
   	  else if(_keytest(RR_UP)&&!(i--)) i = 3;
   	  else if(_keytest(RR_ENTER)||_keytest(RR_2ND)) {
   	  	if(i == 3) Exit();
   	  	else if(i == 2) Info();
     		else playGame(i);
        drawHomeScreen();
    	} else if(_keytest(RR_F5)||_keytest(RR_ESC)) Exit();
      OSTimerRestart(APD_TIMER);
    }
  ONERR
    Exit();
  ENDTRY
}



void __attribute__ ((noreturn)) Exit()
{
	ER_success();
	GrayOff();
	memcpy(LCD_MEM,home,LCD_SIZE);
	if(home) free(home);
	SetIntVec(AUTO_INT_1, save_int_1);
	//SetIntVec(AUTO_INT_5, save_int_5);
	void *kbq = kbd_queue();
	unsigned short int key;
	while(OSdequeue(&key, kbq));
#ifdef English
	ST_helpMsg(endingVerses[random(34)]);
#endif
	exit(0);
}

void drawHomeScreen(void)
{
	// I spent about 45 minutes to take over two hundred pictures of a real board
	// This one was hand selected...by me
	int i = 0;
	unsigned char* planeL = GetPlane(LIGHT_PLANE);
	unsigned char* planeD = GetPlane(DARK_PLANE);
	unsigned char* src = homeBackground;

	for(i = 0; i < 100; i++, src += 20, planeL += 30, planeD += 30) {
		memcpy(planeL, src, 20); memcpy(planeD, src + 2000, 20);
	}
}

void Info(void) {
//  memcpy(GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE), LCD_SIZE);
//  GraySetAMSPlane(DARK_PLANE);
  int position = 0, done = FALSE, y = 8, time = 200, wait;
  FontSetSys(F_6x8);
  do {
    if(!--y) {
    	y = 8;
    	position++;
      if(!done && infoText[position] == NULL) done++;
      if(done && (done++ > 14)) return;
    }
    if(!done) DrawBlackStr(80-(DrawStrWidth((char *)infoText[position],F_6x8)>>1),91+y,(char*)infoText[position]);
    ScrollUp160(GetPlane(LIGHT_PLANE), 100);
    ScrollUp160(GetPlane(DARK_PLANE), 100);
    for(wait = 0; wait < time; wait++) {
      pokeIO(0x600005,0b10011);
      if((_keytest(RR_PLUS) || _keytest(RR_UP)) && time) time--;
      if((_keytest(RR_MINUS) || _keytest(RR_DOWN)) && time < 300) time++;
      if(_keytest(RR_F5)) Exit();
    }
  } while(!_keytest(RR_ESC));
}

void pause(void)
{
//           - 0    (Cheap way out)
//            |
//          \___/
  waitOnMenu(0,1,101,1,0b00000000,DONT_USE_LR,DONT_SCROLL);
}

void showPlayerInfo()
{
	// Clear the top of the panel
	DrawColorRect(98,2,157,29,COLOR_WHITE,RECT_FILLED);
	// Player number
	sprintf(buffer, PLAYER_D, game.turn + 1); // 'Player %d'
	BlackStrCentered(RIGHT_PANEL, 5, buffer, F_6x8);
	// Player's Money
  sprintf(buffer, MONEY_D, game.money[game.turn]); // '$%d'
  BlackStrCentered(RIGHT_PANEL, 15, buffer, F_6x8);
  // Name of the square they recide on
  FontSetSys(F_4x6);
  DrawBlackStr(101, 25, propName[game.position[game.turn]]);
}

void youPaid()
{
	sprintf(buffer, YOU_PAID_D, game.pay); // 'you paid $%d'
	BlackStrCentered(RIGHT_PANEL, 42, buffer, F_4x6);
}

int utCalc(int num)
{
	//if(num == 12) return 0;
	//return 1;
	return (num == 12 ? 0 : 1);
}

int rrCalc(int num)
{
	return num/5 - 1;						// 24336 (smallest)
/*  if(num == 5) num = 0;			// 24347
  else if(num == 15) num = 1;
  else if(num == 25) num = 2;
  else num = 3;
  return num;*/
/*if(num == 5) return 0;			// 24353
	else if(num == 15) return 1;
	else if(num == 25) return 2;
	return 3;*/
}

int rrRent(int curRR)
{
  game.numPropOwned = 0;
  int i;
  for(i = 0; i < 4; i++)
    if(game.rrOwner[i] && (game.rrOwner[i] == game.rrOwner[curRR])) {
      if(!game.numPropOwned) game.numPropOwned = 25;
      else game.numPropOwned <<= 1;
    }
  return game.numPropOwned;
}

int lowerHouse(int h1,int h2)
{
	return (game.numHouses[h1] < game.numHouses[h2] ? game.numHouses[h1] : game.numHouses[h2]);
}

enum Bool canAddHouse(int prop)
{
	return ((game.numHouses[prop] <= lowerHouse(houseGroups[prop][0],houseGroups[prop][1])) ? 1 : 0);
}

int higherHouse(int h1,int h2)
{
	return (game.numHouses[h1] > game.numHouses[h2] ? game.numHouses[h1] : game.numHouses[h2]);
}

enum Bool canRemoveHouse(int prop)
{
	return (game.numHouses[prop] >= higherHouse(houseGroups[prop][0],houseGroups[prop][1]) ? 1 : 0);
}

enum Bool groupOwner(int pos)
{
	return (((game.owner[convert[pos]] == game.owner[houseGroups[convert[pos]][0]]) &&
					(game.owner[convert[pos]] == game.owner[houseGroups[convert[pos]][1]]))?1:0);
}
int payDouble(int pos)
{
	return ((groupOwner(pos) && !(game.numHouses[convert[pos]] + game.owner[houseGroups[convert[pos]][0]] +
	  game.numHouses[game.owner[houseGroups[convert[pos]][1]]]))?1:0);
/*	if((((pos == 1)||(pos == 3))&&(game.owner[0] == game.owner[1]))|
  (((pos == 6)||(pos == 8)||(pos == 9))&&((game.owner[2] == game.owner[3])&&(game.owner[3] == game.owner[4])))||
  (((pos == 11)||(pos == 13)||(pos == 14))&&((game.owner[5] == game.owner[6])&&(game.owner[6] == game.owner[7])))||
  (((pos == 16)||(pos == 18)||(pos == 19))&&((game.owner[8] == game.owner[9])&&(game.owner[9] == game.owner[10])))||
  (((pos == 21)||(pos == 23)||(pos == 24))&&((game.owner[11] == game.owner[12])&&(game.owner[12] == game.owner[13])))||
  (((pos == 26)||(pos == 27)||(pos == 29))&&((game.owner[14] == game.owner[15])&&(game.owner[15] == game.owner[16])))||
  (((pos == 31)||(pos == 33)||(pos == 34))&&((game.owner[17] == game.owner[18])&&(game.owner[18] == game.owner[19])))||
  (((pos == 37)||(pos == 39))&&(game.owner[20] == game.owner[21]))) return 1;
  return 0;*/
}

int isOwner(int pos, int player)
{
  // This routine takes 3 compressed bytes off compared to the old one. Wow.
  // Checks if the player is the owner of a square. Starts with railroads, then utilities, then property
  if(((pos == 5 || pos == 15 || pos == 25 || pos == 35)&&(game.rrOwner[rrCalc(pos)] == player))||
     ((pos == 18 || pos == 12)&&(game.utOwner[utCalc(pos)] == player))||
     ((game.owner[convert[pos]] == player)&&((pos == 1)||(convert[pos] > 0))))
    return 1;
  return 0;
}

void drawPropInfo(int o, enum Bool m, int mC, int pC)
{
	FontSetSys(F_4x6);
	// Owner
	if(!o) sprintf(buffer, OWNER_NONE);
	else sprintf(buffer, OWNER_D, o);
	DrawBlackStr(45, 37, buffer);
	// Purchase Cost
	sprintf(buffer, COST_D, pC);
	DrawBlackStr(45, 45, buffer);
	// Mortgage Status
	if(!m) DrawBlackStr(45, 53, MORTGAGED_NO);
	else DrawBlackStr(45, 53, MORTGAGED_YES);
	// Mortgage Cost
	sprintf(buffer, COST_D, mC);
	DrawBlackStr(54, 61, buffer);
}

void showPropCard(int i)
{
	// Draw the property card
	DrawColorRect(43,9,116,92,COLOR_LIGHTGRAY,RECT_EMPTY);	// Shadow
	DrawColorRect(43,8,115,91,COLOR_BLACK,RECT_EMPTY);			// Black Outline
	DrawColorRect(43,8,115,27,COLOR_BLACK,RECT_EMPTY);			// Black bar separating the header from white space
	DrawColorRect(44,28,114,90,COLOR_WHITE,RECT_FILLED);		// Draw the empty white space
	DrawColorRect(44,9,114,26,COLOR_LIGHTGRAY,RECT_FILLED); // Draw the gray filling in the header space
	FontSetSys(F_4x6);
	DrawBlackStr(45, 29, propName[i]); // Property Name (universal)

	if(convert[i] == -2) {				//// Utility ////
		BlackStrCentered(79, 13, UTILITY, F_8x10);
		drawPropInfo(game.utOwner[utCalc(i)], game.utMortgaged[utCalc(i)], 75, 150);
		if(!game.utOwner[0]&&!game.utOwner[1]) DrawBlackStr(45, 85, RENT_0);	// Rent Cost
		else if((game.utOwner[0] != game.utOwner[1])&&(game.utOwner[0] != 0)) DrawBlackStr(45, 85, RENT_2X);
		else DrawBlackStr(45, 85, RENT_10X);
	} else if(convert[i] == -1) {	//// Railroad ////
		BlackStrCentered(79, 13, RAILROAD, F_8x10);
		drawPropInfo(game.rrOwner[rrCalc(i)], game.rrMortgaged[rrCalc(i)], 100, 200);
		sprintf(buffer, RENT_D, rrRent(i));
		DrawBlackStr(45, 85, buffer);
	} else {											//// Property ////
		BlackStrCentered(79, 13, PROPERTY, F_8x10);
		drawPropInfo(game.owner[convert[i]], game.mortgaged[convert[i]], mortgageCost[convert[i]], buyCost[convert[i]]);
		sprintf(buffer, NUM_HOUSES_D, game.numHouses[convert[i]]); // Number of Houses
		DrawBlackStr(45, 69, buffer);
		sprintf(buffer, COST_D, houseCost[convert[i]]); // House Cost
		DrawBlackStr(54, 77, buffer);
		if(game.owner[convert[i]] != 0) // Rent Cost
		sprintf(buffer, RENT_D, rent[game.numHouses[convert[i]]][convert[i]] * (payDouble(game.position[game.turn])+1));
		else sprintf(buffer, RENT_0);
		DrawBlackStr(45, 85, buffer);
	}
}

void showStats(int i)
{
  //dispPiece(game.position[game.turn]); // Erase current square
  i = 1;
  //dispPiece(1); // Show the current position
  do {
		centerBoard(i);
    showPropCard(i);
    keyPressed = waitOnMenu(0,1,101,1,0b01000000,USE_LR,DONT_SCROLL);
    //if(i < 30) dispPiece(i); // Erase current square
    if(keyPressed == OPTION_LEFT) {
     	if(i == 39) i = 1;              // If the position is Boardwalk, move it to Medit. Avenue
     	else if(!convert[++i]) i++;     // Otherwise, the position advances one square, and if that is not a property
     	                                // square, advance one more. I can do this because a property square is NEVER more
     	                                // than 2 squares ahead of another property square
    } else if(keyPressed == OPTION_RIGHT) {
      if(i == 1) i = 39;              // If the position is Medit. Avenue, move it to Boardwalk
     	else if(!convert[--i]) i--;     // Or else go back one
    }
    //if(i < 30) dispPiece(i); // Hightlight new square
  } while(keyPressed != OPTION_2);
}

void endGame(int winner) {
	unsigned char* plane1 = GetPlane(0); unsigned char* dest1 = plane1; unsigned char* src1 = ending1;
	unsigned char* plane2 = GetPlane(1); unsigned char* dest2 = plane2; unsigned char* src2 = ending2;
	int i;
	memset(GetPlane(LIGHT_PLANE), 0, LCD_SIZE);
	memset(GetPlane(DARK_PLANE), 0, LCD_SIZE);
	for (i=0;i<41;i++,src1+=20,src2+=20,dest1+=30,dest2+=30) {
		memcpy(dest1,src1,20);
		memcpy(dest2,src2,20);
	}
	BlackStrCentered(81, 55, CONGRAGULATIONS, F_8x10);
	sprintf(buffer, PLAYER_D, winner);
	BlackStrCentered(81, 75, buffer, F_8x10);
	pause();
}

void putForSale(int cost)
{
	// NO LONGER Returns the width of the widest option
//	int w1, w2;
	sprintf(buffer, FOR_SALE_D, cost);
	BlackStrCentered(RIGHT_PANEL, 50, buffer, F_4x6);
	/*w1 = */BlackStrCentered(RIGHT_PANEL, 64, BUY_IT, F_4x6);
	/*w2 = */BlackStrCentered(RIGHT_PANEL, 71, LEAVE_IT, F_4x6);
	//if(w2 > w1) w1 = w2;
	/*w2 = */BlackStrCentered(RIGHT_PANEL, 78, INFO, F_4x6);
	//if(w2 > w1) w1 = w2;
	//return w1;
}

void sold(void)
{
	quickSaveScr();
	DrawPopup(73 - soldWidth, 36, 85 + soldWidth, 60);
	BlackStrCentered(80, 44, SOLD, F_8x10);
	if(!game.aiOn[game.turn]) pause();
	quickRestoreScr();
}

/*void clearPanel(short option)
{
	DrawColorRect(98,option,157,97,COLOR_WHITE,RECT_FILLED);
}*/

void quickSaveScr(void) {
	memcpy(LCD_tmp1,GetPlane(LIGHT_PLANE),LCD_SIZE);
	memcpy(LCD_tmp2,GetPlane(DARK_PLANE),LCD_SIZE);
}

void quickRestoreScr(void) {
	memcpy(GetPlane(LIGHT_PLANE),LCD_tmp1,LCD_SIZE);
	memcpy(GetPlane(DARK_PLANE),LCD_tmp2,LCD_SIZE);
}

int arraySum8(int array[8])
{
	int i, sum = 0;
	for(i = 0; i < 8; i++)
	  sum += array[i];
	return sum;
}

void heartBeat(void) {
	unsigned short i;
	for(i = 0; i < 65535; i++);
}

void fadeOut(int x1, int y1, int x2, int y2) {
	if(game.animation) {
		heartBeat();
		DrawColorRect(x1,y1,x2,y2,INVERSE_LIGHT,RECT_FILLED);
		heartBeat();
		DrawColorRect(x1,y1,x2,y2,INVERSE,RECT_FILLED);
		heartBeat();
		DrawColorRect(x1,y1,x2,y2,INVERSE_LIGHT,RECT_FILLED);
	}
}

void debtMenu(int player)
{
	do {
		// Show their stats
		clearPanel(FULL);
		showPlayerInfo();

		// Display their options
		BlackStrCentered(RIGHT_PANEL, 40, DEBT, F_8x10);
		BlackStrCentered(RIGHT_PANEL, 57, PROPERTY, F_4x6);
		BlackStrCentered(RIGHT_PANEL, 66, TRADE, F_4x6);
		BlackStrCentered(RIGHT_PANEL, 75, FORFEIT, F_4x6);

		if(game.aiOn[player]) keyPressed = inDebt();
		else keyPressed = waitOnMenu(99, 156, 55, 9, 0b11100000, DONT_USE_LR, SCROLL_BOARD);
		fadeOut(99,55 + 9 * (keyPressed - 1),156,55 + 9 *  keyPressed - 1);
		// Erase the entire info area and redraw their stats
		DrawColorRect(98,2,157,97,COLOR_WHITE,RECT_FILLED);
		// Player number
		sprintf(buffer, PLAYER_D, player + 1); // 'Player %d'
		BlackStrCentered(RIGHT_PANEL, 5, buffer, F_6x8);
		// Player's Money
		sprintf(buffer, MONEY_D, game.money[player]); // '$%d'
		BlackStrCentered(RIGHT_PANEL, 15, buffer, F_6x8);
		// Name of the square they recide on
		FontSetSys(F_4x6);
		DrawBlackStr(101, 25, propName[game.position[player]]);


		if(keyPressed == 1) property();
		else if(keyPressed == 2) trade();
		else if(keyPressed == 3) { // Forfeit
			game.stillPlaying[player] = 0;
			clearProp(player);
			break;
		}
	// Keep going until the player has squeezed their way out of debt
	} while(game.money[player] < 0);
}

void jailMenu(void)
{
	// Clear the old property name (jail), and display the new one (in jail)
	DrawColorRect(102,25,113,29,COLOR_WHITE,RECT_FILLED);
	FontSetSys(F_4x6); // Set font size to little
	DrawBlackStr(101, 25, IN_JAIL);

	// Display their options
	BlackStrCentered(RIGHT_PANEL, 40, IN_JAIL, F_8x10);
	BlackStrCentered(RIGHT_PANEL, 57, ROLL, F_4x6);
	BlackStrCentered(RIGHT_PANEL, 66, PAY_50, F_4x6);
	if(game.getOutFree[game.turn]) BlackStrCentered(RIGHT_PANEL, 75, USE_CARD, F_4x6);

	if(game.aiOn[game.turn]) keyPressed = inJail();
	else keyPressed = waitOnMenu(99, 156, 55, 9, 0b11000000 + (game.getOutFree[game.turn]?0b10000:0), 0, 0);
	fadeOut(99,55 + 9 * (keyPressed - 1),156,55 + 9 * keyPressed - 1);
	clearPanel(BOTTOM);

	// Option: Roll //
	if(keyPressed == OPTION_1) {
		rollDice();
		if(game.rolled_1 == game.rolled_2) { // Rolled doubles, get out
			game.inJail[game.turn] = 0;
			game.gotOut = 1;
			BlackStrCentered(RIGHT_PANEL, 54, DOUBLES, F_4x6);
		} else if(game.inJail[game.turn]++ >= 3) { // 3rd roll, get out
			game.money[game.turn] -= 50;
			game.freeParking += 50;
			game.inJail[game.turn] = 0;
			game.gotOut = 1;
			BlackStrCentered(RIGHT_PANEL, 54, THIRD_ROLL, F_4x6);
		} else { // Still in Jail
			game.gotOut = 0;
			BlackStrCentered(RIGHT_PANEL, 54, STILL, F_4x6);
			BlackStrCentered(RIGHT_PANEL, 60, IN_JAIL, F_4x6);
		}
	// Option: Pay $50 //
	} else if(keyPressed == OPTION_2) {
		game.money[game.turn] -= 50;
		game.freeParking += 50;
		game.inJail[game.turn] = 0;
		game.gotOut = 1;
		rollDice();
	// Option: Use Card //
	} else {
		game.getOutFree[game.turn]--;
		game.inJail[game.turn] = 0;
		game.gotOut = 1;
		rollDice();
	}
	// If the player got out of jail, let them know
	if(game.gotOut) BlackStrCentered(RIGHT_PANEL, 60, GET_OUT, F_4x6);
	// Refresh their money in case they paid $50
	showPlayerInfo();
	pause();
	// Erase their current position
	//dispPiece(game.position[game.turn]);
}

void clearProp(int player)
{
	int i;
	game.stillPlaying[player] = 0;
	for(i = 0; i < 22; i++)
		if(game.owner[i] == player + 1) {
			game.owner[i] = 0;
			game.mortgaged[i] = 0;
			game.numHouses[i] = 0;
		}
	for(i = 0; i < 4; i++)
		if(game.rrOwner[i] == player + 1) {
			game.rrOwner[i] = 0;
			game.rrMortgaged[i] = 0;
		}
	for(i = 0; i < 2; i++)
		if(game.utOwner[i] == player + 1) {
			game.utOwner[i] = 0;
			game.utMortgaged[i] = 0;
		}
}

void editPlayers(void)
{
  int cursorX = 0, cursorY = 0;
  int isWhatShould = 1;     // For the blinking cursor, is it the color it should be?
  int i;
	FontSetSys(F_6x8);

  DrawPopup(10,6,150,93);

  for(i = 1; i <= 8; i++) {
    sprintf(buffer,PLAYER_D_AI_HUMAN, i);
    DrawBlackStr(14,10*i+1,buffer);
  }

  isWhatShould = 0; cursorX = 0; cursorY = 0;
  for(i = 0; i < 8; i++)
    settingsCursor(game.stillPlaying[i]+game.aiOn[i], i);

  OSFreeTimer(USER_TIMER);
  OSRegisterTimer(USER_TIMER, 15);

  do {
  	while(1) {
	    do {
	      pokeIO(0x600005,0b10111);
	      // Check for APD
				checkAPD();
	      if(OSTimerExpired(USER_TIMER)) {
	        settingsCursor(cursorX, cursorY);
	        if(isWhatShould++ == 1) isWhatShould = 0;
	        OSTimerRestart(USER_TIMER);
	      }
	    } while(!_rowread(0));

	    OSTimerRestart(USER_TIMER);
	    OSTimerRestart(APD_TIMER);

	    if(isWhatShould) settingsCursor(cursorX, cursorY);
	    if(_keytest(RR_F5)) Exit();
	    else if(_keytest(RR_ESC)) break;
	    else if(_keytest(RR_LEFT) &&cursorX)        cursorX--;
	    else if(_keytest(RR_RIGHT)&&(cursorX != 2)) cursorX++;
	    else if(_keytest(RR_UP)   &&cursorY)        cursorY--;
	    else if(_keytest(RR_DOWN) &&(cursorY != 7)) cursorY++;
	    else if(_keytest(RR_ENTER) || _keytest(RR_2ND)) {
	      settingsCursor(game.stillPlaying[cursorY]+game.aiOn[cursorY], cursorY);
	      if(!cursorX) game.stillPlaying[cursorY] = game.aiOn[cursorY] = 0;
	      else if(cursorX == 1) {
	      	game.stillPlaying[cursorY] = 1;
	      	game.aiOn[cursorY] = 0;
	      } else game.stillPlaying[cursorY] = game.aiOn[cursorY] = 1;
	      settingsCursor(game.stillPlaying[cursorY]+game.aiOn[cursorY], cursorY);
	    }
	    settingsCursor(cursorX, cursorY);
	    isWhatShould = 1;
	    heartBeat();
    }
    // Keep repeating until there are at least 2 players playing
  } while(arraySum8((int *)game.stillPlaying) < 2);
  OSFreeTimer(USER_TIMER);
}

unsigned long GNI(int xPos) {
	unsigned long int result = 0;
	int i;

	while(1) {
		// If they are allowed to type more digits, give them a cursor
		if(result < 1000000)
			sprintf(buffer,"$%lu_",result);
		else
			sprintf(buffer,"$%lu",result);
		// Erase the previous text
		DrawColorRect(xPos-31,17,xPos+31,26,COLOR_LIGHTGRAY,RECT_FILLED);
		// Draw the final result
		BlackStrCentered(xPos,19,buffer,F_6x8);
		// Erase the previous number
		DrawColorRect(xPos-31,17,xPos+31,26,INVERSE,RECT_FILLED);

		// Slow down the keypresses
		heartBeat();

		while(!_rowread(0)) {
  	  // Set the calc into low-power mode
      pokeIO(0x600005,0b10011);
      // Check for APD
			checkAPD();
		}

		// Exit if teacher key is pressed
		if(_keytest(RR_F5)) Exit();
		// Check for enter. Exit if true
		if((_keytest(RR_ENTER) || _keytest(RR_RIGHT) || _keytest(RR_LEFT) || _keytest(RR_DOWN))) return result;
		// Check for backspace. Erase the last digit off of the number if true
		if(_keytest(2,6)) result /= 10;
		// Check for number keys, make sure the number isn't too big
		if(result < 1000000)
			for(i = 0; i < 10; i++)
				if(_keytest(row[i],col[i]))
					result = result * 10 + i;
	}
}

int waitOnMenu(unsigned int xStart, unsigned int xEnd, unsigned int yStart, unsigned int optionHeight,
                        unsigned char menuOptions, enum Bool useLR, enum Bool scrollBoard) {
  if(_keytest(RR_F5)) Exit();
  int i = -1, cursorPos = 0;

	// If the cursor does not start with the first option, find which one is first
  while(i < 8)
    if((unsigned char)(menuOptions << ++i) >= 0b10000000) {
      cursorPos = i;
      break;
  }

	// Only need the highlighted square if there are options
  if(menuOptions)
    DrawColorRect(xStart,yStart+optionHeight*cursorPos,xEnd,yStart+optionHeight*(cursorPos+1)-1,INVERSE,RECT_FILLED);

	// Prevent rapid key repeats (mainly for L/R uses)
  heartBeat();

  while(1) {
    do {
  	  // Set the calc into low-power mode
      pokeIO(0x600005,0b10011);
      // Check for APD
			checkAPD();
    } while(!_rowread(0));

		// Cycle through all available keypresses
    if(_keytest(RR_F5)) Exit();
		if(_keytest(RR_APPS)) off();
		if(_keytest(RR_PLUS))  OSContrastUp();
		if(_keytest(RR_MINUS)) OSContrastDn();
		if(useLR && _keytest(RR_LEFT))  return OPTION_LEFT;
		if(useLR && _keytest(RR_RIGHT)) return OPTION_RIGHT;

    if(scrollBoard && _keytest(RR_SHIFT)) controlBoard();
    if(menuOptions) { // If there are options, check to see if the player did anything with them
      if(_keytest(RR_UP) || _keytest(RR_DOWN)) { // Move the cursor
	      DrawColorRect(xStart,yStart+optionHeight*cursorPos,xEnd,yStart+optionHeight*(cursorPos+1)-1,INVERSE,RECT_FILLED);
		    i = cursorPos;
		    if(_keytest(RR_UP)) {
		      while(i > 0)
		        if((unsigned char)(menuOptions << --i) >= 0b10000000) {
		          cursorPos = i; break;
		        }
		    } else if(_keytest(RR_DOWN)) {
		      while(i < 8)
				    if((unsigned char)(menuOptions << ++i) >= 0b10000000) {
				      cursorPos = i; break;
				    }
		    }
		    DrawColorRect(xStart,yStart+optionHeight*cursorPos,xEnd,yStart+optionHeight*(cursorPos+1)-1,INVERSE,RECT_FILLED);
		  }
		  // If ENTER or 2ND was pressed, return the current option. Add one because cursorPos starts at 0, not 1
		  else
				if(_keytest(RR_ENTER) || _keytest(RR_2ND))
					return cursorPos + 1;
	  } else
			// If there aren't any options and the user pressed enter, exit out of the function
	  	if(_keytest(RR_ENTER) || _keytest(RR_2ND))
	  		return 0;
    OSTimerRestart(APD_TIMER);
    heartBeat(); // Pause so the keys don't repeat rapidly
  }
}

void settingsCursor(int cursorX, int cursorY)
{
  DrawColorRect(xStart[cursorX],(cursorY*10)+10,xStart[cursorX+1]-6,(cursorY*10)+18,INVERSE,RECT_FILLED);
}

void addPrevNext(int stats[2][40], int col)
{
	int tempArray[40];
	int row = 0;       // Current row the name will be displayed on
	int pos = 0;       // Position within the stats array
	int i = 0;         // Position within the temp array

	for(i = 0; i < 40; i++)
		tempArray[i] = stats[col][i];

	// Go through and copy every one back to the original array
	for(i = 0; i < 40; i++, pos++) {
		// If it is 0, stop because we are at the end
		if(!tempArray[i]) break;
		// Copy the element of the array
		stats[col][pos] = tempArray[i];

		// If we are at the seventh row, check how many more we have
		// If there is one more, just copy it
		// Otherwise, if there is more than one mark a 'Next' and 'Previous'
		if(row++ == 6) {
			if(!tempArray[i + 2]) {
				if(tempArray[i + 1])
					stats[col][pos + 1] = tempArray[i + 1];
			} else {
				stats[col][++pos] = 2; // Flag this as Next
				stats[col][++pos] = 1; // Flag it as Previous
				row = 1;
			}
		}
	}
}

void trade(void)
{
	//quickSaveScr();

	// I really need to cut back on these variables
	const char *tradeNames[] = {NULL,PREVIOUS,NEXT,MONEY,GET_OUT_FREE,propName[5],propName[15],
		propName[25],propName[35],propName[12],propName[28],propName[1],propName[3],propName[6],propName[8],propName[9],
		propName[11],propName[13],propName[14],propName[16],propName[18],propName[19],propName[21],propName[23],propName[24],
		propName[26],propName[27],propName[29],propName[31],propName[33],propName[34],propName[37],propName[39]};
	int counter = 0;
	int tradePartner;
	int i;
	int cursorPos[2] = {0,0};		// Current cursor position
	int lastOptions[2] = {0,0};	// What the last screen of options looks like
	int maxCur[2] = {0,0};			// The number of screens, highest the cursor can go
	unsigned long int moneyToTrade = 0;

	memset(options, 0, 2*40*sizeof(int)); // Set all possible trading flags to zero
	memset(stats, 0, 2*40*sizeof(int)); // Set all possible statistics to zero

	// Prompt the player which player to trade with
	// Show all numbers, but only turn on the ones that are not this player and are still playing
	keyPressed = 0;
	DrawPopup(76 - partnerWidth, 15, 84 + partnerWidth, 84);
	BlackStrCentered(80, 19, PARTNER, F_4x6);
	for(i = 0; i < 8; i++) {
		sprintf(buffer, PER_D, i + 1);
		GraySetAMSPlane(LIGHT_PLANE);
		DrawStr(78, 26 + 7 * i, buffer, A_NORMAL);
		if(game.stillPlaying[i] && i != game.turn) {
			BlackStrCentered(80, 26 + 7 * i, buffer, F_4x6);
			keyPressed += 0b10000000 >> i;
		}
	}
	if(game.aiOn[game.turn]) tradePartner = tradepartner(keyPressed);
	else tradePartner = waitOnMenu(80 - partnerWidth, 80 + partnerWidth, 25, 7, keyPressed, DONT_USE_LR, DONT_SCROLL) - 1;

	// Go through and see what the two players have to offer and mark them
	// Once done scanning, add in 'Previous' and 'Next' at the beginning and end of each page
	// maxCur[0] is a temporary variable used to make sure it loops twice
	for(column = game.turn, maxCur[0] = 0; maxCur[0] < 2; column = tradePartner, maxCur[0]++) {
		counter = 0;
		// Money
		if(game.money[column]) options[column][counter++] = 3;
		// Get out Free
		if(game.getOutFree[column]) options[column][counter++] = 4;
		// RR's
		for(i = 0; i < 4; i++)
			if(game.rrOwner[i] == column + 1)
				options[column][counter++] = 5 + i;
		// Utilities
		for(i = 0; i < 2; i++)
			if(game.utOwner[i] == column + 1)
				options[column][counter++] = 9 + i;
		// Property
		for(i = 0; i < 22; i++)
			if(game.owner[i] == column + 1)
				options[column][counter++] = 11 + i;
		addPrevNext(options, column);
	}
	maxCur[0] = 0;
	// Go through the entire array
	// If we are on the last page then see how many are displayed on that page
	// Store this information for quick retrieval later in the routine
	for(column = 0; column < 2; column++)
		for(i = 0; i < 40; i += 8)
			if(options[column][i + 7] != 2) {
				for(maxCur[column] = i, i = 0; i < 8; i++)
					if((options[column][maxCur[column] + i] != 0))
						lastOptions[column] += 0b10000000 >> i;
				break;
			}

	memset(GetPlane(LIGHT_PLANE), 0, LCD_SIZE);
	memset(GetPlane(DARK_PLANE), 0, LCD_SIZE);
	Sprite16XOR(69,45,23,revolving_arrows_16,GetPlane(LIGHT_PLANE));
	Sprite16XOR(69,45,23,revolving_arrows_16+23,GetPlane(DARK_PLANE));
	Sprite8(85,48,17,revolving_arrows_8,GetPlane(LIGHT_PLANE),SPRT_XOR);
	Sprite8(85,49,13,revolving_arrows_8+17,GetPlane(DARK_PLANE),SPRT_XOR);
	sprintf(buffer,PLAYER_D,game.turn + 1);
	BlackStrCentered(35, 3, buffer, F_8x10);
	sprintf(buffer,PLAYER_D,tradePartner + 1);
	BlackStrCentered(125, 3, buffer, F_8x10);

	column = 0;

	DrawColorRect(3,17,67,98,COLOR_LIGHTGRAY,RECT_FILLED);
	DrawColorRect(2,16,66,97,COLOR_BLACK,RECT_EMPTY);
	DrawColorRect(94,17,158,98,COLOR_LIGHTGRAY,RECT_FILLED);
	DrawColorRect(93,16,157,97,COLOR_BLACK,RECT_EMPTY);

	quickSaveScr();

	while(1) {
		// Go back to the templated screen
		quickRestoreScr();

		// Display the names of all the options and a checkmark next to them if they are selected
		for(counter = 0; counter < 2; counter++)
			for(i = 0; i < 8; i++) {
				if(i || !stats[counter][i])
					BlackStrCentered(34 + 91 * counter, 19 + i * 10, tradeNames[options[counter][cursorPos[counter] + i]], F_4x6);
				else { // If the player is trading money, display the amount
					sprintf(buffer,"$%lu",moneyToTrade);
					BlackStrCentered(34 + 91 * counter, 19, buffer, F_4x6);
				}
				if(stats[counter][cursorPos[counter] + i])
					Sprite8(3 + 91 * counter, 19 + i * 10, 4, checkMark, GetPlane(DARK_PLANE), SPRT_XOR);
			}

		// Check the current columnumn
		// If in the middle, see if they want to move or finish up the trade
		// If on the ends, check to see if they change pages, move to the middle, or select one of the options
		if(column == 2) {
			if(game.aiOn[game.turn]) keyPressed = tradeCenter();
			else keyPressed = waitOnMenu(68, 92, 44, 25, 0b10000000, USE_LR, DONT_SCROLL);
			fadeOut(68, 44, 92, 68);

			if(keyPressed == OPTION_RIGHT) column = 1;
			else if(keyPressed == OPTION_LEFT) column = 0;
			else if(keyPressed == OPTION_1) { // Trade it
				lastOptions[0] = lastOptions[1] = 0;

				// Make sure this is a legal transaction, both sides get something
				// Store the amount of things being traded in the lastOptions array
				for(column = 0; column < 2; column++)
					for(i = 0; i < 40; i++)
						if(stats[column][i]) lastOptions[column]++;

				// Continue only if both sides are trading something
				if(lastOptions[0] && lastOptions[1]) {

					// Prompt to see if the other player agrees to trade
					sprintf(buffer,PLAYER_D_AGREE,tradePartner);
					i = (DrawStrWidth(buffer,F_4x6) >> 1);
					DrawPopup(74 - i, 32, 86 + i, 69);
					BlackStrCentered(80, 37, buffer, F_4x6);
					BlackStrCentered(80, 46, NO, F_6x8);
					BlackStrCentered(80, 57, YES, F_6x8);
					heartBeat();
					if(game.aiOn[tradePartner]) agreedToTrade = agreeToTradeIt(game.turn, moneyToTrade);
					else agreedToTrade = waitOnMenu(79 - i, 81 + i, 44, 11, 0b11000000, DONT_USE_LR, DONT_SCROLL) - 1;
					fadeOut(79 - i, 44 + 11 * agreedToTrade, 81 + i, 54 + 11 * agreedToTrade);

					// Both players agree to this trade
					if(agreedToTrade) {

						// Go through both players and continue until the options have stopped
						// lastOptions[0] is the player getting rid of the stuff, and lastOptions[1] is the player receiving the stuff
						// keyPressed is the amount of money to transfer
						for(lastOptions[0] = game.turn, lastOptions[1] = tradePartner, column = 0; column < 2;
																											lastOptions[1] = game.turn, lastOptions[0] = tradePartner, column++)
							for(i = 0; options[maxCur[0]][i]; i++) {
								if(stats[column][i]) {
									/*if(options[column][i] == 1 || options[column][i] == 2) {
										// Error
										Exit();
									} else */
									if(options[column][i] == 3) {
										game.money[lastOptions[0]] -= moneyToTrade;
										game.money[lastOptions[1]] += moneyToTrade;
									} else if(options[column][i] == 4) {
										game.getOutFree[lastOptions[0]]--;
										game.getOutFree[lastOptions[1]]++;
									} else if(options[column][i] <= 8) {
										game.rrOwner[options[column][i] - 5] = lastOptions[1] + 1;
									} else if(options[column][i] <= 10) {
										game.utOwner[options[column][i] - 9] = lastOptions[1] + 1;
									} else if(options[column][i] > 10) {
										game.owner[options[column][i] - 11] = lastOptions[1] + 1;
									}
								}
							}
					}
				}
				// If any of the go-ahead conditions were not met, then go back
				keyPressed = OPTION_TRADE; // Once it goes back, make sure the player doesn't roll
				return;
			}
		} else {
			// If this is the last page of options, only let the user select the options that are on
			// Otherwise, turn them all on
			if(game.aiOn[game.turn])
				keyPressed = selectTradeOption((cursorPos[column] == maxCur[column] ? lastOptions[column] : 0b11111111),column);
			else keyPressed = waitOnMenu(3 + 91 * column, 65 + 91 * column, 17, 10,
													(cursorPos[column] == maxCur[column] ? lastOptions[column] : 0b11111111), USE_LR, DONT_SCROLL);

			if((keyPressed == OPTION_RIGHT && !column)||((keyPressed == OPTION_LEFT) && (column == 1)))
				column = 2; // Move to the center
			else if((keyPressed == OPTION_1) && (cursorPos[column] > 0) && (options[column][cursorPos[column]] == 1))
				cursorPos[column] -= 8; // Move up 8 options
			else if((keyPressed == OPTION_8)&&(cursorPos[column]<maxCur[column])&&(options[column][cursorPos[column] + 7] == 2))
				cursorPos[column] += 8; // Move down 8 options
			else {
				// If the player is trying to trade some money, do some special things
				if((!cursorPos[column]) && (keyPressed == 1)) {
					// Oops, player is trying to trade money from both sides
					// Unselect the non-active side
					if((!stats[column][0]) && (stats[0][0] + stats[1][0] == 1))
						stats[(column ^ 1)][0] = 0;

					// Prompt for how much money the player should trade
					// If they don't want anything, turn the money checkmark off
					if(!(moneyToTrade = GNI(34 + 91 * column))) stats[column][0] = 0;
				}

				stats[column][cursorPos[column] + keyPressed - 1] ^= 1; // Select/unselect the option
			}
		}
	}
}

void property(void)
{
  int i = 0;
  if(((i == 1)||(convert[i] > 0))&&!isOwner(game.position[game.turn],game.turn+1))
    i = game.position[game.turn]; // Let the player stay on the same game.position, if they own it
  else {        // If the player is not the owner of this square, move somewhere else
    i = 0;      // Start with the first square, will increase to property before checks are run
    game.numPropOwned = 1;   // Don't remember what this variable is for  ;)
    do {        // Keep looping until the square is owned by this player, or we run out of squares ;)
    	i++;      // Increase one square, not very efficient -- but oh well
    } while(!isOwner(i,game.turn+1) && (i < 40));
  }

  //quickSaveScr();

  if(i > 39) { // If the player doesn't own any property, don't let them do anything
    DrawPopup(75 - dontOwnPropWidth, 40, 85 + dontOwnPropWidth, 56);
		BlackStrCentered(80, 46, DONT_OWN_PROP, F_4x6);
    if(!game.aiOn[game.turn]) pause();
  } else { // If the player does own property, let them modify it
    //dispPiece(game.position[game.turn]); // Erase current square
    //dispPiece(i); // Show the current position

    do {
			clearPanel(FULL);
      showPlayerInfo();
			centerBoard(i);

      // This variable will be used for passing the available options to the menu
      // By default, turn on un/mortgage and cancel
      game.numPropOwned = 0b10010000;

			if(!game.mortgaged[convert[i]]) { // See if the property is not mortgaged
				if(((i == 1)||convert[i]) && !game.numHouses[convert[i]]) // Let them mortgage only if there isn't houses on it
					BlackStrCentered(RIGHT_PANEL, 45, MORTGAGE, F_4x6);
				else
					game.numPropOwned -= 0b10000000; // Otherwise turn off the option
			} else BlackStrCentered(RIGHT_PANEL, 45, UNMORTGAGE, F_4x6);

			// Always let them cancel
      BlackStrCentered(RIGHT_PANEL, 75, CANCEL, F_4x6);

    	if((i == 1)||convert[i]) { // If the property isn't a RR or utility, display house info
        sprintf(buffer, NUM_HOUSES_D, game.numHouses[convert[i]]);
        BlackStrCentered(RIGHT_PANEL, 32, buffer, F_4x6);
        // When playing the real game, I never thought there were this many conditions you had to meet to add a house
        if((game.numHouses[convert[i]] == 4)&&(!game.mortgaged[convert[i]])&&(game.numHotelsLeft)&&
          	groupOwner(i)&&canAddHouse(convert[i])&&game.numHotelsLeft) {
          BlackStrCentered(RIGHT_PANEL, 55, ADD_HOTEL, F_4x6); game.numPropOwned += 0b01000000; }
        else if((game.numHouses[convert[i]] <= 3)&&(!game.mortgaged[convert[i]])&&(game.numHousesLeft)&&
            groupOwner(i)&&canAddHouse(convert[i])&&game.numHousesLeft) {
         	BlackStrCentered(RIGHT_PANEL, 55, ADD_HOUSE, F_4x6); game.numPropOwned += 0b01000000; }
        if((game.numHouses[convert[i]] == 5)&&(!game.mortgaged[convert[i]])&&
        		groupOwner(i)&&canRemoveHouse(convert[i])&&(game.numHousesLeft >= 4)) {
          BlackStrCentered(RIGHT_PANEL, 65, REMOVE_HOTEL, F_4x6); game.numPropOwned += 0b00100000; }
        else if((game.numHouses[convert[i]] >= 1)&&(!game.mortgaged[convert[i]])&&
        		groupOwner(i)&&canRemoveHouse(convert[i])) {
          BlackStrCentered(RIGHT_PANEL, 65, REMOVE_HOUSE, F_4x6); game.numPropOwned += 0b00100000; }
      }

      if(_keytest(RR_F5)) Exit(); // In case the AI gets stuck in an endless loop
      if(game.aiOn[game.turn]) keyPressed = propertyInfo(game.numPropOwned,i,game.numHouses[convert[i]]);
      else keyPressed = waitOnMenu(99,156,43,10,game.numPropOwned,USE_LR,SCROLL_BOARD); // Wait for a key press
      if((keyPressed != OPTION_LEFT)&&(keyPressed != OPTION_RIGHT)) // If they didn't go left or right, fade out
        fadeOut(99,43 + 10 * (keyPressed - 1),156,43 + 10 *  keyPressed - 1);

      //dispPiece(i);																						// Erase the current square
      if(keyPressed == OPTION_LEFT) {
        do {																									// Keep looping until the square is owned by this player
        	if(i == 39) i = 1;																	// Loop around the board, if at Boardwalk
        	else i++;																						// Otherwise increase one square
        } while(!isOwner(i,game.turn+1));											// Keep looping
      } else if(keyPressed == OPTION_RIGHT) {
        do {
        	if(i == 1) i = 39;
        	else i--;
        } while(!isOwner(i,game.turn+1));

      // They didn't press an arrow key, so check to see if they selected one of the options
      } else if(keyPressed == OPTION_1) {											// Mortgage/Unmortgage
        if(!game.mortgaged[convert[i]]) {       							// If the property is not mortgaged,
        	game.mortgaged[convert[i]] = 1;											// mortgage it
        	game.money[game.turn] += mortgageCost[convert[i]];	// and give them the money
        } else {																							// otherwise,
        	game.mortgaged[convert[i]] = 0;											// unmortgage it
        	game.money[game.turn] -= mortgageCost[convert[i]];	// and take away the money
        }
      } else if(keyPressed == OPTION_2) { // Add a house
				// If the player is adding a hotel, subtract one from the total and add back the four houses
				// Otherwise, subtract the house
				if(game.numHouses[convert[i]]++ == 4) {
					game.numHotelsLeft--;
					game.numHousesLeft += 4;
				} else
					game.numHousesLeft--;
				game.money[game.turn] -= houseCost[convert[i]];
      } else if(keyPressed == OPTION_3) { // Remove a house
				// If the player is removing a hotel, subtract add from the total and subtract the four houses
				// Otherwise, add the house
				if(game.numHouses[convert[i]]-- == 5) {
					game.numHotelsLeft++;
					game.numHousesLeft -= 4;
				} else
					game.numHousesLeft++;
				game.money[game.turn] += houseCost[convert[i]] >> 1; // Give back half of the money
      }
      //dispPiece(i); // Highlight the new square
	  } while(keyPressed != OPTION_4);
  }
	//quickRestoreScr();
	//centerBoard(game.position[game.turn]);
}

void settingsIcon(int x, int y, int num)
{
	if(num > 6) num = 0; // Loop around
	if(num == -1) num = 6;
	Sprite32_mask(x,y,32,(unsigned long *)setting_icons + (num << 6), (unsigned long *)setting_icons + (num << 6) + 32);
}

void reloadSettings(int pos)
{
	quickRestoreScr();

	Sprite16XOR(30, 14, 16, (unsigned short *)settings_arrowl, GetPlane(DARK_PLANE));
	Sprite16XOR(114, 14, 16, (unsigned short *)settings_arrowr, GetPlane(DARK_PLANE));
	settingsIcon(64, 6, pos);
	settingsIcon(2, 60, pos - 1);
	settingsIcon(126, 60, pos + 1);

	// Show information about the icon
	BlackStrCentered(79,52,optionTitles[pos],F_6x8); // Title
	BlackStrCentered(79,77,settingsDescriptions1[pos],F_4x6); // Description - pt. 1
	BlackStrCentered(79,88,settingsDescriptions2[pos],F_4x6); // Description - pt. 2
	if(pos > 1) {
		if(*settingsOptions[pos - 2]) BlackStrCentered(79,62,ON,F_8x10);
		else BlackStrCentered(79,62,OFF,F_8x10);
	}
}

void settingsMenu()
{
	int pos = 0;
	int i;
	int p;

	// Setup a blank menu and save the screen
	memset(GetPlane(LIGHT_PLANE), 0, LCD_SIZE);
	memset(GetPlane(DARK_PLANE), 0, LCD_SIZE);
	Sprite16XOR(37, 45, 16, (unsigned short *)settings_cornerl, GetPlane(LIGHT_PLANE));
	Sprite16XOR(107, 45, 16, (unsigned short *)settings_cornerr, GetPlane(LIGHT_PLANE));
	DrawColorRect(53, 44, 106, 60, COLOR_LIGHTGRAY, RECT_FILLED);
	DrawColorRect(36, 61, 123, 99, COLOR_LIGHTGRAY, RECT_FILLED);
	quickSaveScr();

	// Load the icons and text
	reloadSettings(pos);

	heartBeat();

	while(1) {
		do {
			// Set the calc into low-power mode
			pokeIO(0x600005,0b10011);
			// Check for APD
			checkAPD();
		} while(!_rowread(0));

		if(_keytest(RR_F5)) Exit();
		if(_keytest(RR_PLUS)) OSContrastUp();
		if(_keytest(RR_MINUS)) OSContrastDn();
		if(_keytest(RR_APPS)) off();
		if(_keytest(RR_RIGHT)) {
			// Animate the piece only if animation is turned on
			if(game.animation)
				// For animation:
				//	-Call up the blank settings screen
				//	-Move the two icons along the predetermined path for 7 frames, pausing between each one
				for(i = 0; i < 7; i++) {
					quickRestoreScr();
					settingsIcon(79 - settingsIconPlacementX[6 - i], settingsIconPlacementY[6 - i], pos);
					settingsIcon(48 + settingsIconPlacementX[i], settingsIconPlacementY[i], pos + 1);
					// The teacher key will be checked 10500 times during each animation!
					for(p = 0; p < 1500; p++) if(_keytest(RR_F5)) Exit();
				}
			// Loop around if the position has gone too far then reload the screen
			if(++pos > 6) pos = 0;
			reloadSettings(pos);
		}
		if(_keytest(RR_LEFT)) {
			if(game.animation)
				for(i = 0; i < 7; i++) {
					quickRestoreScr();
					settingsIcon(79 - settingsIconPlacementX[i], settingsIconPlacementY[i], pos - 1);
					settingsIcon(48 + settingsIconPlacementX[6 - i], settingsIconPlacementY[6 - i], pos);
					for(p = 0; p < 1500; p++) if(_keytest(RR_F5)) Exit();
				}
			if(--pos < 0) pos = 6;
			reloadSettings(pos);
		}
		if(_keytest(RR_ENTER) || _keytest(RR_2ND)) {	// User wants to change the current icon
			if(!pos) return;														// Start the game by exiting from this function
			else if(pos == 1)	editPlayers();						// Edit the players
			else *settingsOptions[pos - 2] ^= 1;				// For the rest, invert what they are (off->on, on->off)
			reloadSettings(pos);												// Show the settings
		}
		heartBeat(); // Slow down the key repeat time
	}
}

void playGame(enum Bool gameType)
{
  //////////////////////
  // System variables //
  //////////////////////
  int i;
  unsigned int cardDispY[] = {26,34,42,50,58,66};


  /////////////////
  // Player data //
  /////////////////
  // Declare these variables now in case something got screwed
  // up with the file IO and one of the vars are missing
  memset(game.stillPlaying, 0, sizeof(int) * 8); game.stillPlaying[0] = game.stillPlaying[1] = 1;
  memset(game.aiOn, 0, sizeof(int) * 8); game.aiOn[1] = 1;
  memset(game.inJail, 0, sizeof(int) * 8);
  memset(game.position, 0, sizeof(int) * 8);
  //memset(game.money, 1500, 8);
  memset(game.getOutFree, 0, sizeof(int) * 8);
  //memset(game.inJailRolls, 0, sizeof(int) * 8);
  game.players = game.numPlaying = game.turn = game.chanceCard = game.cchestCard = game.rolled_1 = game.rolled_2 =
          game.numDoubles = game.pay = game.payRRdouble = game.payUtmore = game.numPropOwned = game.gotOut = 0;
  memset(game.owner, 0, sizeof(int) * 22);
  memset(game.mortgaged, 0, sizeof(int) * 22);
  memset(game.numHouses, 0, sizeof(int) * 22);
  memset(game.rrOwner, 0, sizeof(int) * 4);
  memset(game.rrMortgaged, 0, sizeof(int) * 4);
  memset(game.utOwner, 0, sizeof(int) * 2);
  memset(game.utMortgaged, 0, sizeof(int) * 2);
  //memset(game.chanceCards, 0, sizeof(int) * 15);
  //memset(game.cchestCards, 0, sizeof(int) * 15);
  for(i = 0; i < 22; i++) game.chanceCards[i] = game.cchestCards[i] = i;

  // For the AI
	memset(game.saving, 0, sizeof(int) * 2);
	memset(game.dontBuyHouses, 0, sizeof(int) * 2);
  game.houseToBuy = game.numHousesToBuy = 0;

  // System vars
  game.animation = game.limitHouses = game.inDebt = 1;
  game.FPJackpot = game.autoSave = 0;
  game.numHousesLeft = 32;
  game.numHotelsLeft = 12;
  game.freeParking = 500;

  // For the board
  game.boardX = game.boardY = 0;

  for(i = 0; i < 8; i++)
    game.money[i] = 1500;

  /////////////////////
  // Background data //
  /////////////////////
  //unsigned char* plane = GetPlane(0);
  //unsigned char* destination = plane; unsigned char* source = background;

  //////////////////////////////////////////////////
  // Shuffle the Chance and Community Chest Cards //
  //////////////////////////////////////////////////
  for(i = 0; i < 15; i++) {
    game.chanceCard = random(22);                          // Pick a random card to trade with
    game.cchestCard = game.chanceCards[game.chanceCard];   // Store this one in an unused variable
    game.chanceCards[game.chanceCard] = i;                 // Put the original card in the current slot
    game.chanceCards[i] = game.cchestCard;                 // Update the random card

    game.cchestCard = random(22);                          // Do the same with the cchest cards
    game.chanceCard = game.cchestCards[game.cchestCard];
    game.cchestCards[game.cchestCard] = i;
    game.cchestCards[i] = game.chanceCard;
  }
  game.chanceCard = 0; game.cchestCard = 0; // Reset these cards


#ifdef OWNER_OF_PROP // These options are for debugging (and winning the game!)
    for(i = 0; i < 22; i++) game.owner[i] = OWNER_OF_PROP;
	  game.rrOwner[0] = game.rrOwner[1] = game.rrOwner[2] = game.rrOwner[3] = OWNER_OF_PROP;
	  game.utOwner[0] = game.utOwner[1] = OWNER_OF_PROP;
    game.getOutFree[OWNER_OF_PROP - 1] = 300;
#warning You have Debugging Mode currently turned On
#ifdef NUM_HOUSES
    for(i = 0; i < 22; i++) game.numHouses[i] = NUM_HOUSES;
#endif
#endif

  // If it is a new game, or loading a game does not work then start a new one by loading the settings menu
/*  if((gameType == LOAD_GAME) && loadGame()) {

  } else {
		settingsMenu();
	}*/
	if((gameType == LOAD_GAME) && loadGame()) {}else
		settingsMenu();

  // Figure out the number of players
  for(i = 0; i < 8; i++)
  	if(game.stillPlaying[i])
  		game.players = i + 1; // Figure out the last player's number, and that is the max the main loop will go to
  heartBeat();

	///////////////
	// Main loop //
	///////////////
  while(1)
  {
    // Do not start the turn at zero in case if a game was loaded in the middle
  	if(game.turn == game.players) game.turn = 0; // If we have gone through all of the players, start over
  	for(; game.turn < game.players; game.turn++) // 'Turn' is one less than the player number
  	{
      // If the player is not active, go to the next one
      if(!game.stillPlaying[game.turn]) continue;

      // Search how many players are left
      // If there is only one player left playing then declare them the winner
      game.numPlaying = 0;
      for(i = 0; i < game.players; i++) game.numPlaying += game.stillPlaying[i];
      if(game.numPlaying == 1)
        for(i = 0; i < game.players; i++)  // Scan through all of the players
          if(game.stillPlaying[i]) {       // If it is this player,
            endGame(i+1);                  // announce them winner
            Exit();                        // and exit to the main screen
          }


      ///////////////
      // Main Menu //
      ///////////////
      do {
        // Do a check for the teacher key, just in case of an endless loop
        if(_keytest(RR_F5)) Exit();

				//////////////////////
				// Setup the screen //
				//////////////////////
				// Draw the right panel, 2 borders and an empty inside
				DrawColorRect(96,0,159,99,COLOR_LIGHTGRAY,RECT_EMPTY);
				DrawColorRect(97,1,158,98,COLOR_LIGHTGRAY,RECT_EMPTY);
				clearPanel(FULL);

				// Draw the board and the player's piece
				centerBoard(game.position[game.turn]);

				//clearPanel();

        // Draw the houses
        //drawHouses();

        // Show this person's information
        showPlayerInfo();

        // Display the board and player's piece
        //dispPiece(game.position[game.turn]);

        // If they have auto save turned on, save the game
        // If there's a problem saving the game, turn AutoSave off
        // Let all of the graphics come on before displaying message
        if(game.autoSave && !saveGame()) {
        	quickSaveScr();
          DrawPopup(75 - autosaveWidth, 39, 85 + autosaveWidth, 60);
          BlackStrCentered(80, 44, ERROR_SAVING_GAME, F_4x6);
          BlackStrCentered(80, 51, AUTOSAVE_TURNED_OFF, F_4x6);
          pause();
          game.autoSave = 0;
          quickRestoreScr();
        }

        // Draw the main menu. Give them the 'save' option only if autosave is not on
				Sprite32_mask(112,38,56 - game.autoSave * 10,(unsigned long *)mainMenuOptions,(unsigned long *)mainMenuOptions);

        if(game.aiOn[game.turn]) // AI_handleMainMenu
          keyPressed = handleMainMenu();
        else
        //////////////////////////////
        // Get the current keypress //
        //////////////////////////////
          // If autosave is turned on, remove it from the list of options
          keyPressed = waitOnMenu(99,156,36,10,0b11111100 - (game.autoSave << 2),USE_LR,SCROLL_BOARD);
        fadeOut(99,36 + 10 * (keyPressed - 1),156,36 + 10 *  keyPressed - 1);

				clearPanel(FULL);

        if(keyPressed == OPTION_STATS)					showStats(1);
        else if(keyPressed == OPTION_TRADE)			trade();
        else if(keyPressed == OPTION_PROPERTY)	property();
        else if(keyPressed == OPTION_FORFEIT) { // Forefeit
          clearProp(game.turn);
          goto endLoop;
        } else if(keyPressed == OPTION_SAVE) {
					if(saveGame()) {
						DrawPopup(75 - savedWidth, 36, 85 + savedWidth, 60);
						BlackStrCentered(80, 44, SAVED, F_8x10);
					} else {
						DrawPopup(75 - errorWidth, 36, 85 + errorWidth, 60);
						BlackStrCentered(80, 44, ERROR, F_8x10);
					}
          if(!game.aiOn[game.turn]) pause();
        }

      } while(keyPressed != OPTION_ROLL);     // While they don't want to roll, keep repeating



			if(keyPressed == OPTION_ROLL)           // If they want to roll the dice (so that if the player
			{                                       // forefeited, it does not continue with their turn)
        //dispPiece(game.position[game.turn]);  // Clear the highlighted square
				game.rolled_1 = 0;                    // Set it so they haven't rolled yet

				centerBoard(game.position[game.turn]);
				clearPanel(FULL);
				showPlayerInfo();

				// If the player is in jail, give them a menu to get out
				if(game.inJail[game.turn])
					jailMenu();

        if(!game.inJail[game.turn]) {										// If they are not in jail, let them take their turn
          if(!game.rolled_1) {													// If they have not yet rolled (out of jail)
            rollDice();																	// Roll & display the dice (the function covers everything)

            if((game.rolled_1 == game.rolled_2)&&(game.numDoubles == 2)) {	// Rolled 3 doubles to jail
              game.position[game.turn] = 10;																// Move the player in jail
        	    game.inJail[game.turn] = 1;																		// And sign em' in!
              //dispPiece(game.position[game.turn]);
							centerBoard(game.position[game.turn]);
							BlackStrCentered(RIGHT_PANEL, 54, THIRD_DOUBLE, F_4x6);
							BlackStrCentered(RIGHT_PANEL, 60, GO_TO_JAIL, F_4x6);
        	    DrawColorRect(102,25,157,29,COLOR_WHITE,RECT_FILLED);					// Display 'In Jail'
              DrawBlackStr(101, 25, IN_JAIL);
              pause();
              game.numDoubles = 0;
              continue; // Move on to the next person's turn
            }

            // Let them know if they got doubles only if they aren't heading for 'Goto jail'
            if(!game.gotOut&&(game.rolled_1 == game.rolled_2)&&(game.position[game.turn] + (game.rolled_1 << 1) != 30)) {
							BlackStrCentered(RIGHT_PANEL, 54, DOUBLES, F_4x6);
							BlackStrCentered(RIGHT_PANEL, 60, GO_AGAIN, F_4x6);
            }
          }

          // Animate the player's moving
          // This may happen if they get out of jail
          if(game.animation)
            for(i = game.position[game.turn]; i<(signed int)(game.position[game.turn]+game.rolled_1+game.rolled_2); i++) {
							centerBoard(i - (i >= 40 ? 40: 0)); // If they pass go, subtract 40 from i to get the board position
							heartBeat();
              if(_keytest(RR_F5)) Exit();                  // Make sure they don't want to quit
            }

          game.position[game.turn] += game.rolled_1 + game.rolled_2; // Update their position

          if(game.position[game.turn] >= 40) {   // If the player passed go
            game.position[game.turn] -= 40;      // Calculate how far past go they went, then set their position to it
            game.money[game.turn] += 200;        // Add the $200 bonus
          }

					// In case a Chance or Community Chest Card moves a player to a different position,
					// have it reevaluate the new position
					evaluatePosition:

					centerBoard(game.position[game.turn]);
					clearPanel(FULL);
          showPlayerInfo();


          /////////////////////////////////////////////
          // Figure out the square the player is on, //
          //              and act on it              //
          /////////////////////////////////////////////

          if(!game.position[game.turn]) { // GO
            // Do nothing, already got the money. Put this here because otherwise it will try to take us to a prop square
          } else if((game.position[game.turn] == 2)||(game.position[game.turn] == 17)|| // Community Chest
                    (game.position[game.turn] == 32)) {
            // Save the current screen
            quickSaveScr();
            // Draw the next card, and if we are at the bottom of the deck, start over
            if(game.cchestCard++ >= 14) game.cchestCard = 0;
            DrawColorRect(24,24,137,77,COLOR_LIGHTGRAY,RECT_EMPTY);      // Gray shadow
            DrawColorRect(23,23,136,76,COLOR_BLACK,RECT_EMPTY);          // Black border
            DrawColorRect(24,24,135,75,COLOR_LIGHTGRAY,RECT_FILLED);     // Gray inside of the card
            Sprite32(48,42,17,cchestA,GetPlane(LIGHT_PLANE),SPRT_AND);   // Display the 'Community Chest' text
            Sprite32(80,42,17,cchestB,GetPlane(LIGHT_PLANE),SPRT_AND);   // in the middle of the card
            for(i = 0; i < 6; i++)
            	BlackStrCentered(80, cardDispY[i], cchest[i][game.cchestCards[game.cchestCard]], F_6x8);
            if(!game.aiOn[game.turn]) pause();
            // Restore the previous screen
            quickRestoreScr();
            // Decide what to do based on the card's ID #. Use switch because it produces smaller code
            switch(game.cchestCards[game.cchestCard]) {
            	case 0: //Bank error in your favor. Collect $200
                game.money[game.turn] += 200;
            	  break;
            	case 1: //You inherit $100
                game.money[game.turn] += 100;
            	  break;
            	case 2: //Go directly to Jail. Do not pass GO, do not collect $200
                game.inJail[game.turn] = 1;
                game.position[game.turn] = 10;
								centerBoard(game.position[game.turn]);
            	  break;
            	case 3: //Pay school tax of $150
                game.money[game.turn] -= 150;
                game.freeParking += 150;
            	  break;
            	case 4: //Income tax refund. Collect $20
                game.money[game.turn] += 20;
            	  break;
            	case 5: //Recieve for services $25
                game.money[game.turn] += 25;
            	  break;
            	case 6: //Life insurance matures. Collect $100
                game.money[game.turn] += 100;
            	  break;
            	case 7: //Get out of Jail FREE. This card may be kept until needed, or sold
                game.getOutFree[game.turn]++;
            	  break;
            	case 8: //Advance to GO (Collect $200)
                game.position[game.turn] = 0;
								goto evaluatePosition;
            	  break;
            	case 9: //You are assessed for street repairs. Pay:  $40 per house  $115 per hotel
                game.pay = 0;
                for(i = 0; i < 22; i++) // Figure out the number of houses
                  if((game.owner[i] - 1 == game.turn)&&(game.numHouses[i])&&(game.numHouses[i] != 5))
                    game.pay += game.numHouses[i];
                keyPressed = 40*game.pay; game.pay = 0;// A tempary variable, I don't want to have to create a new one
                for(i = 0; i < 22; i++) // Figure out the number of hotels
                  if((game.owner[i] - 1 == game.turn)&&(game.numHouses[i] == 5)) game.pay++;
                game.pay = game.pay * 115 + keyPressed; // Figure out the total amount due, $115 for hotel + houses
                game.money[game.turn] -= game.pay; // Subtract that from money
                game.freeParking += game.pay;
                youPaid();
                if(!game.aiOn[game.turn]) pause();
            	  break;
            	case 10: //You won Second Prize in a Beauty Contest Collect $10
                game.money[game.turn] += 10;
            	  break;
            	case 11: //From sale of stock you get $45
                game.money[game.turn] += 45;
            	  break;
            	case 12: //Grand Opera Opening. Collect $50 from Every Player.
                for(i = 0; i < 8; i++)
									if(game.stillPlaying[i]) {
										game.money[i] -= 50;
										game.money[game.turn] += 50;
									}
            	  break;
            	case 13: //Pay Hospital $100
                game.money[game.turn] -= 100;
                game.freeParking += 100;
            	  break;
            	case 14: //Xmas fund matures Collect $100
                game.money[game.turn] += 100;
            	  break;
            	default:
            	  break;
            }
          } else if((game.position[game.turn] == 5)||(game.position[game.turn] == 15)||
                    (game.position[game.turn] == 25)||(game.position[game.turn] == 35)) { //RR
            game.payRRdouble = 1;
            LoadRailroad: // w00t! Go BASIC!!!! This is just to jump to from the 'Chance' portion, and charge the player
            /////////////////////////////////////////////////////////////
            // -If nobody owns the RR, put it up for sale              //
            // -If it is mortgaged, let them unmortgage it or pay rent //
            // -Otherwise, they own it                                 //
            /////////////////////////////////////////////////////////////
            if(!game.rrOwner[rrCalc(game.position[game.turn])]) { // No one owns it: put it up for sale
              do {
	              BlackStrCentered(RIGHT_PANEL, 40, RR, F_8x10);
                putForSale(200);
                if(game.aiOn[game.turn]) keyPressed = buyProperty();
                else keyPressed = waitOnMenu(99, 156, 63,7,0b11100000,DONT_USE_LR,SCROLL_BOARD);
                fadeOut(99,63 + 7 * (keyPressed - 1),156,63 + 7 *  keyPressed - 1);
                DrawColorRect(98, 31, 157, 96, COLOR_WHITE, RECT_FILLED);
                if(keyPressed == OPTION_BUY_IT) {
                  game.money[game.turn] -= 200; // Subtract $200 from their money
                  game.rrOwner[rrCalc(game.position[game.turn])] = game.turn + 1; // Mark this player as the owner
                  game.rrMortgaged[rrCalc(game.position[game.turn])] = 0; // Just in case, make sure it isn't mortgaged
                  sold();
                } else if(keyPressed == OPTION_INFO) {
                  quickSaveScr();
                	showPropCard(game.position[game.turn]);
                	pause();
                	quickRestoreScr();
                }
              } while(keyPressed == OPTION_INFO);
            } else if(!(game.rrMortgaged[rrCalc(game.position[game.turn])])) { // Not mortgaged, see if they own it
              if(game.rrOwner[rrCalc(game.position[game.turn])] != game.turn + 1) { // Player doesn't own it
                game.pay = rrRent(game.turn) * game.payRRdouble;
                game.money[game.turn] -= game.pay; // Subtract the money from the person who landed on the RR
                game.money[game.rrOwner[rrCalc(game.position[game.turn])]-1] += game.pay; // Add the money to the owner
                youPaid();
                sprintf(buffer, TO_PLAYER_D, game.rrOwner[rrCalc(game.position[game.turn])]);
                BlackStrCentered(RIGHT_PANEL, 54, buffer, F_4x6);
              } else
              	BlackStrCentered(RIGHT_PANEL, 42, YOU_OWN_IT, F_4x6);
            } else
            	BlackStrCentered(RIGHT_PANEL, 42, MORTGAGED, F_4x6);
          } else if((game.position[game.turn] == 7)||(game.position[game.turn] == 22)||
                    (game.position[game.turn] == 36)) { // Chance
            // Save the current screen
            quickSaveScr();
            // Draw the next card, and if we are at the bottom of the deck, start over
            game.chanceCard++;
            if(game.chanceCard > 14) game.chanceCard = 0;
            DrawColorRect(24,24,137,77,COLOR_LIGHTGRAY,RECT_EMPTY);
            DrawColorRect(23,23,136,76,COLOR_BLACK,RECT_EMPTY);
            DrawColorRect(24,24,135,75,COLOR_LIGHTGRAY,RECT_FILLED);
            Sprite32(48,44,13,chanceA,GetPlane(LIGHT_PLANE),SPRT_AND);
            Sprite32(80,44,13,chanceB,GetPlane(LIGHT_PLANE),SPRT_AND);
            for(i = 0; i < 6; i++)
							BlackStrCentered(80, cardDispY[i], chance[i][game.chanceCards[game.chanceCard]], F_6x8);
            if(!game.aiOn[game.turn]) pause();
            // Restore the previous screen
            quickRestoreScr();
            switch(game.chanceCards[game.chanceCard]) {
            	case 0: //Take a ride on the Reading. If you pass GO, collect $200
                if(!((game.position[game.turn] <= 4)&&(game.position[game.turn] > 0))) game.money[game.turn] += 200;
                game.position[game.turn] = 5;
								goto evaluatePosition;
            	  break;
            	case 1: //Make general repairs on all your property. For each House pay $25. For each Hotel pay $100
                game.pay = 0;
                for(i = 0; i < 22; i++) { // Figure out the number of houses
                  if((game.owner[i] - 1 == game.turn)&&(game.numHouses[i])&&(game.numHouses[i] != 5))
                  game.pay += game.numHouses[i];
                }
                keyPressed = 25*game.pay; game.pay = 0;// A tempary variable, I don't want to have to create a new one
                for(i = 0; i < 22; i++) // Find the # of hotels
                  if((game.owner[i] - 1 == game.turn)&&(game.numHouses[i] == 5)) game.pay++;
                game.pay = game.pay * 100 + keyPressed; // Figure out the total amount due
                game.money[game.turn] -= game.pay; // Subtract that from money
                game.freeParking += game.pay;
                youPaid();
                if(!game.aiOn[game.turn]) pause();
            	  break;
            	case 2: //Pay poor tax of $15
                game.money[game.turn] -= 15;
                game.freeParking += 15;
            	  break;
            	case 3: // Advance to the nearest RR and pay Twice the Rental.
            	        // If RR is UNOWNED, you may buy it from the Bank
                game.payRRdouble = 2;
                if(game.position[game.turn] <= 5) game.position[game.turn] = 5; // Find the nearest RR
                else if(game.position[game.turn] <= 15) game.position[game.turn] = 15;
                else if(game.position[game.turn] <= 25) game.position[game.turn] = 25;
                else if(game.position[game.turn] <= 35) game.position[game.turn] = 35;
                else { game.money[game.turn] += 200; game.position[game.turn] = 5; }
                goto LoadRailroad;
            	case 4: //Advance to St. Charles Place. If you pass GO, collect $200
                if(game.position[game.turn] > 11) game.money[game.turn] += 200;
                game.position[game.turn] = 11;
                goto evaluatePosition;
            	  break;
            	case 5: //Advance to Illinois Ave.
                if(game.position[game.turn] > 24) game.money[game.turn] += 200;
                game.position[game.turn] = 24;
                goto evaluatePosition;
            	  break;
            	case 6://Bank pays you dividend of $50
                game.money[game.turn] += 50;
            	  break;
            	case 7: //Advance to Nearest Utility. UNOWNED: you may buy it from the Bank.
            	        //                            OWNED: throw dice and pay ten times the amount thrown
                if(game.position[game.turn] <= 12) game.position[game.turn] = 12;
                else if(game.position[game.turn] <= 28) game.position[game.turn] = 28;
                else { game.money[game.turn] += 200; game.position[game.turn] = 12; }
                // Unowned
                if(!game.utOwner[utCalc(game.position[game.turn])]) goto evaluatePosition;
                // Owned
								centerBoard(game.position[game.turn]);
								rollDice();
								game.pay = 10 * (game.rolled_1 + game.rolled_2);
								game.money[game.turn] -= game.pay;
								game.money[game.utOwner[utCalc(game.position[game.turn])] - 1] += game.pay;
								youPaid();
            	  break;
            	case 8: //Advance to GO. (Collect $200)
                game.money[game.turn] += 200;
                game.position[game.turn] = 0;
								centerBoard(game.position[game.turn]);
            	  break;
            	case 9: //Go back 3 spaces
                game.position[game.turn] -= 3;
								goto evaluatePosition;
            	  break;
            	case 10: //Go directly to Jail. Do not pass GO, do not collect $200
                game.inJail[game.turn] = 1;
                game.position[game.turn] = 10;
								centerBoard(game.position[game.turn]);
            	  break;
            	case 11: //Take a walk on the Boardwalk. Advance token to Boardwalk
                game.position[game.turn] = 39;
                goto evaluatePosition;
            	  break;
            	case 12: //You have been elected Chairman of the board. Pay each player $50
                for(i = 0; i < 8; i++)
									if(game.stillPlaying[i]) {
										game.money[i] += 50;
										game.money[game.turn] -= 50;
										if(game.money[i] < 0) debtMenu(i);
									}
            	  break;
            	case 13: //Your Building and loan matures. Collect $150
            	  game.money[game.turn] += 150;
            	  break;
            	case 14: //Get out of Jail FREE. This card may be kept until needed, or sold
                game.getOutFree[game.turn]++;
            	  break;
            	default:
                break;
            }
          } else if(game.position[game.turn] == 4) { // Tax Day :)
						DrawColorRect(98, 31, 156, 96, COLOR_WHITE, RECT_FILLED);
						BlackStrCentered(RIGHT_PANEL, 45, TAX_DAY, F_6x8);
						BlackStrCentered(RIGHT_PANEL, 60, DOLLARS_200, F_6x8);
						BlackStrCentered(RIGHT_PANEL, 70, TEN_PERCENT, F_6x8);
						if(game.aiOn[game.turn]) keyPressed = taxDay();
						else keyPressed = waitOnMenu(99,156,59,10,0b11000000,DONT_USE_LR,SCROLL_BOARD); // Wait for a key press
						if(keyPressed == OPTION_1) game.pay = 200;
						else {
							game.pay = game.money[game.turn];
							for(i = 0; i < 22; i++) if(game.owner[i] == game.turn + 1) game.pay += buyCost[i];
							for(i = 0; i < 4; i++) if(game.rrOwner[i] == game.turn + 1) game.pay += 200;
							if(game.utOwner[0] == game.turn + 1) game.pay += 75;
							if(game.utOwner[1] == game.turn + 1) game.pay += 75;
							game.pay /= 10; // Take 10%
						}
            game.money[game.turn] -= game.pay;
            game.freeParking += game.pay;
						DrawColorRect(98, 31, 156, 96, COLOR_WHITE, RECT_FILLED); // Clear right panel
            youPaid();
						if(!game.aiOn[game.turn]) pause();
          } else if(game.position[game.turn] == 10) { // Jail
            // Do nothing, (forever)
          } else if(game.position[game.turn] == 20) { // Free parking
						if(game.FPJackpot) {
							game.money[game.turn] += game.freeParking;
							sprintf(buffer, CONG_YOU_WON_U, (unsigned int)game.freeParking);
							i = (DrawStrWidth(buffer, F_4x6) >> 1);
							DrawPopup(75 - i, 43, 85 + i, 55);
							BlackStrCentered(80, 47, buffer, F_4x6);
							pause();
							centerBoard(game.position[game.turn]);
							clearPanel(FULL);
							showPlayerInfo();
						}
						game.freeParking = 1;
          } else if((game.position[game.turn] == 12)||(game.position[game.turn] == 28)) { // Utilities
            game.payUtmore = 0;
            if(!game.utOwner[utCalc(game.position[game.turn])]) { // No one owns it: put it up for sale
              do {
	              BlackStrCentered(RIGHT_PANEL, 40, UT, F_8x10);
                putForSale(150);
                if(game.aiOn[game.turn]) keyPressed = buyProperty();
                else keyPressed = waitOnMenu(99, 156, 63,7,0b11100000,DONT_USE_LR,SCROLL_BOARD);
                fadeOut(99,63 + 7 * (keyPressed - 1),156,63 + 7 *  keyPressed - 1);
                DrawColorRect(98, 31, 157, 96, COLOR_WHITE, RECT_FILLED);
                if(keyPressed == OPTION_BUY_IT) {
                  game.money[game.turn] -= 150; // Subtract $200 from their money
                  game.utOwner[utCalc(game.position[game.turn])] = game.turn + 1; // Mark this player as the owner
                  game.utMortgaged[utCalc(game.position[game.turn])] = 0; // Just in case, make sure it isn't mortgaged
                  sold();
                } else if(keyPressed == OPTION_INFO) {
                  quickSaveScr();
                	showPropCard(game.position[game.turn]);
                	pause();
                	quickRestoreScr();
                }
              } while(keyPressed == OPTION_INFO);
            } else if(!(game.utMortgaged[utCalc(game.position[game.turn])])) { // Not mortgaged, see if they own it
              if(game.utOwner[utCalc(game.position[game.turn])] != game.turn + 1) { // Player doesn't own it
              	game.numPropOwned = 0;
              	for(i = 0; i < 2; i++)
                  if(game.utOwner[i] == game.utOwner[utCalc(game.position[game.turn])]) game.numPropOwned++;
                if(game.numPropOwned == 1) game.pay = 4 * (game.rolled_1 + game.rolled_2);
                else if((game.numPropOwned == 2)||(game.payUtmore)) game.pay = 10 * (game.rolled_1 + game.rolled_2);
                game.money[game.turn] -= game.pay; // Subtract the money from the person who landed on the Utility
                game.money[game.utOwner[utCalc(game.position[game.turn])]-1] += game.pay; // Add the money to the owner
                youPaid();
                sprintf(buffer, TO_PLAYER_D, game.utOwner[utCalc(game.position[game.turn])]);
                BlackStrCentered(RIGHT_PANEL, 54, buffer, F_4x6);
              } else
              	BlackStrCentered(RIGHT_PANEL, 42, YOU_OWN_IT, F_4x6);
            } else
            	BlackStrCentered(RIGHT_PANEL, 42, MORTGAGED, F_4x6);
          } else if(game.position[game.turn] == 30) { // Go to jail
            game.position[game.turn] = 10;
            game.inJail[game.turn] = 1;
          } else if(game.position[game.turn] == 38) {
            game.money[game.turn] = game.money[game.turn] - 75; // Tax Day again :)
            game.freeParking += 75;
          } else { // Player landed on property
            if(!game.owner[convert[game.position[game.turn]]]) {
              do {
	              BlackStrCentered(RIGHT_PANEL, 40, PROP, F_8x10);
                putForSale(buyCost[convert[game.position[game.turn]]]);
                if(game.aiOn[game.turn]) keyPressed = buyProperty();
                else keyPressed = waitOnMenu(99, 156, 63,7,0b11100000,DONT_USE_LR,SCROLL_BOARD);
                fadeOut(99,63 + 7 * (keyPressed - 1),156,63 + 7 *  keyPressed - 1);
                DrawColorRect(98, 31, 156, 96, COLOR_WHITE, RECT_FILLED);
                if(keyPressed == OPTION_BUY_IT) {
                  game.money[game.turn] -= buyCost[convert[game.position[game.turn]]];
                  game.owner[convert[game.position[game.turn]]] = game.turn + 1;
                  game.mortgaged[convert[game.position[game.turn]]] = 0;
                  sold();
                } else if(keyPressed == OPTION_INFO) {
                  quickSaveScr();
                	showPropCard(game.position[game.turn]);
                	pause();
                	quickRestoreScr();
                }
              } while(keyPressed == OPTION_INFO);
            } else if(!game.mortgaged[convert[game.position[game.turn]]]) { // Not mortgaged -- and someone owns it
              if(game.owner[convert[game.position[game.turn]]] != game.turn + 1) { // Player doesn't own it
                game.pay = rent[game.numHouses[convert[game.position[game.turn]]]][convert[game.position[game.turn]]]
                      * (payDouble(game.position[game.turn])+1);
                game.money[game.turn] -= game.pay; // Subtract the money from the person who landed on the property
                game.money[game.owner[convert[game.position[game.turn]]]-1] += game.pay; // Add the money to the owner

                youPaid();
                sprintf(buffer, TO_PLAYER_D, game.owner[convert[game.position[game.turn]]]);
                BlackStrCentered(RIGHT_PANEL, 54, buffer, F_4x6);
              } else
              	BlackStrCentered(RIGHT_PANEL, 42, YOU_OWN_IT, F_4x6);
            } else
            	BlackStrCentered(RIGHT_PANEL, 42, MORTGAGED, F_4x6);
          }

          // If the player has gone into debt, let them redeem theirselves if the inDebt option is turned on
          if(game.money[game.turn] < 0) {
            if(!game.inDebt)
              clearProp(game.turn);
            else {
							debtMenu(game.turn);
							clearPanel(FULL);
						}
          }

					// If the player is still playing, refresh their information
					// Otherwise, clear all property, mortgages, and houses that belong to them
					if(game.stillPlaying[game.turn]) {
						////////////////////////////////
						// Refresh player information //
						////////////////////////////////
						//     (if still playing)     //
						//clearPanel(FULL);
						DrawColorRect(98,2,157,30,COLOR_WHITE,RECT_FILLED);
						showPlayerInfo();

						if(!game.aiOn[game.turn]) pause();

						if((game.rolled_1 == game.rolled_2)&&!game.inJail[game.turn]&&!game.gotOut)
						{ // Rolled a double and they didn't roll it into or out of jail
							game.turn--;				 // Once the For loop finishes, it
							game.numDoubles++;	 // will be this player's turn again
						} else {
							game.numDoubles = 0; // Otherwise, reset the Double counter
							game.gotOut = 0;
						}
					} else {
						clearProp(game.turn);
					} // End the if statement (for still playing)
        } // End the if statement (for in jail)
      } // End the if statement (for keypress)
      endLoop:
      heartBeat();
	  } // End the for loop
	} // End the while loop
}